ascabin = require '..'


describe 'Function returned by Ascabin', ->

  beforeEach ->
    @originalMethod = sinon.spy (name, done) -> done()
    @boundMethod = ascabin @originalMethod
    @cb = sinon.stub()


  context 'normal call', ->

    beforeEach ->
      @boundMethod 'Jeff', @cb

    it 'calls the original method', ->
      expect(@originalMethod).to.have.been.calledOnce

    it 'provides all given arguments to it', ->
      expect(@originalMethod.args[0]).to.eql ['Jeff', @cb]


  context 'call without callback', ->

    beforeEach ->
      @result = @boundMethod 'Jeff'


    it 'does not call the original method', ->
      expect(@originalMethod).to.have.not.been.called

    it 'returns a function', ->
      expect(@result).to.be.a.function


  context 'call with missing arguments', ->

    it 'throws an exception', ->
      expect(=> @result()).to.throw()
